function tipoAjusteDeTituloReceber() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');
	const self = this;
	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		self.clickByPath(['Parametrização', 'Financeiro', 'Títulos a Receber',
			'Tipo de Ajuste de Título a Receber']);
		geral.esperarLoading();
	};

	// Override funçao Zeedhi, pois não funciona para 'Títulos a Receber'
	this.clickByPath = function (fullPath) {
		let prefix = '.zh-main-menu>.menu-group>.menu-group-items>';
		let child;
		for (const index in fullPath) {
			if (fullPath.hasOwnProperty(index)) {
				if (fullPath[index] == 'Títulos a Receber') {
					child = element.all(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index])).get(1);
				} else {
					child = element(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index]));
				}
				child = child.element(by.xpath('..')).element(by.xpath('..'));
				protractorHelper.click(child);
				prefix = '.sub-menu>';
				browser.sleep(500);
			}
		}
	};

	this.adicionar = (codigo, descricao, tratamentoAjuste, contaContabil, historicoPadrao, tipoAjuste, contabilizaNaBaixa) => {
		geral.clickAndFillFields('CDAJUCTREC', codigo,
			'DSAJUCTREC', descricao);
		geral.selectNatives('IDAJUCTREC', tratamentoAjuste,
			'IDTPAJRECEBER', tipoAjuste,
			'IDCTBAJCTREC', contabilizaNaBaixa);
		geral.searchAndClickGridFields('CDCONTCTBL', contaContabil, 'NMCONTCTBL',
			'DSHISTPADR', historicoPadrao, 'CDHISTPADR');
	};

	this.editar = (descricao, contaContabil, historicoPadrao) => {
		geral.fillField('DSAJUCTREC', descricao);
		geral.searchAndClickGridFields('CDCONTCTBL', contaContabil, 'NMCONTCTBL',
			'DSHISTPADR', historicoPadrao, 'CDHISTPADR');
	};
}
module.exports = new tipoAjusteDeTituloReceber();
